# Getting Started

## Installation

Whether you're a sockethub developer, or application developer, you're probably
going to first have to install sockethub.

* [Installing Sockethub](https://github.com/sockethub/sockethub/blob/master/doc/install.md)


## Application developers

For application developers, there are a few resources that are recommended for
getting started with sockethub.


### Platform Overview

* [Platform Overview](platform_overview)
    This will give you a general overview of what the JSON data looks like,
    and then how to use the sockethub-client library (which abstracts that JSON
    away).

### SockethubClient Library

* [SockethubClient Library](https://github.com/sockethub/sockethub-client).
    This is the main part of sockethub you'll be using, so most of the
    application developer specific documentation will live here.



## Sockethub Platform developers

If you're interested in adding a sockethub platform or extending an existing one
you should check out the following docs.

### Architecture Overview

* [Architecture Overview](architecture_overview.md).
    This document will give you a general overview of how sockethub is
    structured and the control flow from client to platform module and back.

### Adding a Platform

* [Adding a Platform](adding_a_platform.md)
    For a more in-depth explanation of creating your own sockethub platform,
    see the above document.