As the major social network vendors increase their customer lock-in, and the open social web platform alternatives continue to be dispersed and re-invent the wheel, we're faced with many different, mostly non-interoperable platforms, protocols and APIs to choose from.

Developers must spend their time picking and choosing protocols and APIs to integrate into their applications, banking on the increased lock-in of their chosen platforms to ensure the applications’ relevance and longevity. Open-source application developers, are either limited by what they can realize completely in the browser, or faced with tying their application to backend servers to carry out parts of the functionality, or store user data.

As users, we find ourselves losing our autonomous internet identity. In order to interact with our friends, we are forced to choose middleman platforms to sign up with, signing away our rights and fragmenting our user data. In addition, the bright future of HTML5 web applications has been mired by the prospect of being forever tied to their vendors’ proprietary back-end. This restricts their usage and their longevity. If a company goes out of business, the app you purchased can no longer be used because the servers that store the data and provide the back-end logic will no longer be running. Likewise, if the company changes its business plan, they may decide to no longer offer the app, even if you’ve paid for it.

Imagine a world where your web applications are independent and not on rental. Backend services are generalized and you have the option of choosing where your app can tie-in to make use of server resources. Your user data, and app functionality live on, beyond any one vendor’s control.   

Sockethub aims to solve one piece of that puzzle, by implementing a polyglot server that can speak all of the various protocols and APIs of the web today. Exposing a single abstracted interface to application developers, this open platform can be run on any server, and provides social and other interactive messaging functionality to the application. Adding one more building block to the goal of server-independent, server-side functionality, Sockethub can help to free our web applications from vendor lock-in.

